 /*
  * i2c-mpc85xxads.c I2C Interface driver module for the MPC85xxADS board
  * 
  * (C) Copyright 2002,2003 Motorola Inc
  * Xianghua Xiao (x.xiao@motorola.com)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */

#include <linux/delay.h>
#include <linux/slab.h>
#include <linux/version.h>
#include <linux/init.h>
#include <asm/irq.h>
#include <asm/io.h>
#include <linux/module.h>
#include <asm/mpc85xx.h>
#include <linux/i2c.h>
#include <linux/i2c-algo-85xx.h>

static int mpc85xx_i2c_reg(struct i2c_client *client)
{
	return 0;
}


static int mpc85xx_i2c_unreg(struct i2c_client *client)
{
	return 0;
}

static void mpc85xx_i2c_inc_use(struct i2c_adapter *adap)
{
#ifdef MODULE
	MOD_INC_USE_COUNT;
#endif
}

static void mpc85xx_i2c_dec_use(struct i2c_adapter *adap)
{
#ifdef MODULE
	MOD_DEC_USE_COUNT;
#endif
}


static struct i2c_algo_85xx_data mpc85xx_i2c_data = {
	NULL
};

static struct i2c_adapter mpc85xx_i2c_ops = {
	"MPC85xx I2C Interface(non-CPM)",
	I2C_HW_MPC85xx_MPC85xxADS,
	NULL,
	&mpc85xx_i2c_data,
	mpc85xx_i2c_inc_use,
	mpc85xx_i2c_dec_use,
	mpc85xx_i2c_reg,
	mpc85xx_i2c_unreg,
};

int __init i2c_mpc85xxads_init(void) 
{
	int res = -ENODEV;

	printk("i2c-mpc85xx.o: i2c MPC85xx module\n");

	mpc85xx_i2c_data.i2c = ioremap(CCSRBAR + MPC85xx_IIC0_OFFSET,
	                             MPC85xx_IIC0_SIZE);

	if (i2c_mpc85xx_add_bus(&mpc85xx_i2c_ops) < 0)
	{
		goto Done;
	}

	printk("i2c-mpc85xx.o: found device at 0x%08x.\n",
	       (unsigned int)mpc85xx_i2c_data.i2c);

	res = 0;
Done:
	return res;
}


EXPORT_NO_SYMBOLS;

#ifdef MODULE
MODULE_AUTHOR("Xianghua Xiao(x.xiao@motorola.com)");
MODULE_DESCRIPTION("I2C-Bus driver routines for the MPC85xxADS board");


int init_module(void) 
{
	return i2c_mpc85xxads_init();
}

void cleanup_module(void) 
{
	i2c_mpc85xx_del_bus(&mpc85xx_i2c_ops);
}

#endif
