
/*
 * platforms/ng_gsm7248.h
 * 
 * Definitions for Netgear GSM7248
 *
 * Author: Aharon Gadot aharong@radlan.com
 *
 * Copyright 2004 Radlan a Marvell Company Ltd.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#ifndef __PPC_PLATFORMS_NG_GSM7248_H
#define __PPC_PLATFORMS_NG_GSM7248_H

#define BOARD_VENDOR	"Netgear"   /* Changed from Marvell */
#define BOARD_MACHINE	"GSM7248"  /* Changed from MV_PMC8245 */


#define NG_GSM7248_PCI_IRQ              0
#define NG_GSM7248_RTC_IRQ              1
#define NG_GSM7248_UART_IRQ             2
#define NG_GSM7248_ETHERNET_IRQ         3
#define NG_GSM7248_EXTERNAL_INT_IRQ     4

#define NG_GSM7248_NUM_OF_IRQS          16	/* Changed from 5 to 16 -- Arvind */
#define NG_GSM7248_FIRST_IRQ            0

#define i2c_addr ((unsigned *)(0xFC003000))

#define i2cadr &i2c_addr[0]
#define i2cfdr  &i2c_addr[1]
#define i2cccr  &i2c_addr[2]
#define i2ccsr  &i2c_addr[3]
#define i2ccdr  &i2c_addr[4]

#define ETHERNET_1_IDSEL     16
#define ETHERNET_2_IDSEL     18

/* #define CPLD_RESET           0xFF010000 */
#define CPLD_RESET			 0xFFF00100
#define CPLD_LED             0xFF010001
#define CPLD_INT_MASK        0xFF010002
#define CPLD_INT_STATUS      0xFF010003
#define CPLD_INT_CAUSE       0xFF010004

#define NG_GSM7248_TODC_BASE 0xFF040000
#define NG_GSM7248_TODC_SIZE 0x100       /* 256 bytes for TODC */

#define NG_GSM7248_NVRAM_EXT_RAM_ADRS   0x10
#define NG_GSM7248_NVRAM_EXT_RAM_DATA   0x13
#define NG_GSM7248_NVRAM_CONTROLB       0xF

#define CPLD_RESET_VAL       0x00000000

#endif /* __PPC_PLATFORMS_NG_GSM7248_H */

