/*
 * (C) Copyright 2003
 * John W. Linville, LVL7 Systems, Inc., linville@lvl7.com
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * This file contains the configuration parameters for the GSW7224TG board.
 */

#ifndef __CONFIG_H
#define __CONFIG_H

#define CONFIG_MIPS32               1    /* MIPS32 CPU core    */
#define CONFIG_BCM47XX              1    /* in a BCM47xx CPU    */
#define CONFIG_GSW7224TG            1    /* on a GSW7224TG    */

#define CONFIG_BOARD_PRE_INIT       1

#define SB_CLOCK_RATE               100000000

#define CONFIG_BAUDRATE             9600

#define CONFIG_CONS_INDEX           1

/*
 * NS16550 Configuration
 */
#define CFG_NS16550
#define CFG_NS16550_SERIAL

#define CFG_NS16550_REG_SIZE        1

#define CFG_NS16550_CLK             1851851

#define CFG_NS16550_COM1            (0xb8000300)
#define CFG_NS16550_COM2            (0xb8000400)

/* valid baudrates */
#define CFG_BAUDRATE_TABLE          { 9600, 19200, 38400, 57600, 115200 }

#define CONFIG_MENUKEY              1
#define CONFIG_BOOTDELAY            3
#define CONFIG_BOOTCOMMAND          "cp.b bc060000 a0400000 200000 ; " \
                                    "bootm a0400000"

#define CONFIG_SHOW_BOOT_PROGRESS

#define CONFIG_BOOTARGS             "root=/dev/ram"

#define CONFIG_COMMANDS		        (CONFIG_CMD_DFL) \
                                    & ~CFG_CMD_NET /* no net for now...  */
#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP                            /* undef to save memory      */
#define CFG_PROMPT                  "=> "       /* Monitor Command Prompt    */

#define CFG_HUSH_PARSER
#ifdef  CFG_HUSH_PARSER
#define CFG_PROMPT_HUSH_PS2         "> "
#endif

#define CFG_CBSIZE                  1024        /* Console I/O Buffer Size   */
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)  /* Print Buffer Size */
#define CFG_MAXARGS                 16        /* max number of command args*/
#define CFG_BARGSIZE                CFG_CBSIZE

#define CFG_MALLOC_LEN              128*1024

#define CFG_BOOTPARAMS_LEN          128*1024

#define CFG_HZ                      SB_CLOCK_RATE

#define CFG_SDRAM_BASE              0xA0000000
#define CFG_MAX_RAM_SIZE            0x08000000

#define CFG_LOAD_ADDR               0xA0400000    /* default load address    */

#define CFG_MEMTEST_START           0xA0100000
#define CFG_MEMTEST_END             0xA0800000

/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CFG_MAX_FLASH_BANKS         1       /* max number of memory banks */
#define CFG_MAX_FLASH_SECT          (135)   /* max number of sectors on one chip */

#define CFG_FLASH_BASE0_PRELIM      0xBC000000 /* Flash Bank #1 */

/* The following #defines are needed to get flash environment right */
#define CFG_MONITOR_BASE            TEXT_BASE
#define CFG_MONITOR_LEN             (192 << 10)

#define CFG_INIT_SP_OFFSET          0x400000

#define CFG_FLASH_BASE              CFG_FLASH_BASE0_PRELIM

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT        (15000 * (CFG_HZ / 1000))
#define CFG_FLASH_WRITE_TOUT        (15000 * (CFG_HZ / 1000))

#define CFG_ENV_IS_IN_FLASH         1

/* Address and size of Primary Environment Sector       */
#define CFG_ENV_ADDR                0xBC040000
#define CFG_ENV_SIZE                0x20000

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_DCACHE_SIZE             16384
#define CFG_ICACHE_SIZE             16384
#define CFG_CACHELINE_SIZE          16

/*-----------------------------------------------------------------------
 * PCI stuff
 */
#undef  CONFIG_PCI

#endif    /* __CONFIG_H */
